<template>
  <div class="app-container">
    <el-card shadow="hover" class="mb-[10px]">
      <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px" size="default" class="ry_form">
        <el-form-item label="商品名称" prop="productId">
          <!--        <el-input v-model="queryParams.productId" placeholder="请输入PRODUCT_ID" clearable @keyup.enter="handleQuery" />-->
          <el-select
            v-model="queryParams.productId"
            placeholder="请选择商品"
            filterable
            remote
            reserve-keyword
            :remote-method="getProductListByName"
            :loading="productSelectLoading"
            clearable
            style="width: 100%"
          >
            <el-option v-for="item in productSelectOption" :key="item.id" :label="item.name" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="sku编码" prop="outSkuId">
          <el-input v-model="queryParams.outSkuId" placeholder="请输入sku编码" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item label="价格" prop="price">
          <el-input v-model="queryParams.price" placeholder="请输入价格" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <!--      <el-form-item label="展示图片" prop="pic">
        <el-input v-model="queryParams.pic" placeholder="请输入展示图片" clearable @keyup.enter="handleQuery" />
      </el-form-item>-->
        <el-form-item class="flex_one tr">
          <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
    </el-card>

    <el-card shadow="hover">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['pms:sku:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>
      <el-table v-loading="loading" :data="pmsSkuList" @selection-change="handleSelectionChange">
        <el-table-column label="商品名称" align="center" prop="productName" />
        <el-table-column label="sku编码" align="center" prop="outSkuId" />
        <el-table-column label="价格" align="center" prop="price" />
        <!--      <el-table-column label="展示图片" align="center" prop="pic" />-->
        <el-table-column label="展示图片" prop="pic" align="center">
          <template v-slot="{ row }">
            <el-image v-if="row.pic" :src="row.pic" :preview-teleported="true" :preview-src-list="[row.pic]" class="small-img circle-img" />
          </template>
        </el-table-column>
        <el-table-column label="商品销售属性" align="center" prop="spData" />
        <el-table-column label="操作" width="180" align="center" class-name="small-padding fixed-width">
          <template v-slot="scope">
            <el-button text type="primary" @click="handleUpdate(scope.row)" v-hasPermi="['pms:sku:edit']">修改</el-button>
            <el-button text type="primary" @click="handleDelete(scope.row)" v-hasPermi="['pms:sku:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改sku信息对话框 -->
    <el-dialog :title="title" v-model="open" width="50%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="138px" inline class="dialog-form-two">
        <el-form-item label="商品名称" prop="productId">
          <!--          <el-input v-model="form.productId" placeholder="请输入商品名称" />-->
          <el-select
            v-model="form.productId"
            placeholder="请选择商品"
            filterable
            remote
            reserve-keyword
            :remote-method="getModalProductListByName"
            :loading="productModalSelectLoading"
            clearable
            style="width: 240px"
          >
            <el-option v-for="item in productModalSelectOption" :key="item.id" :label="item.name" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="sku编码" prop="outSkuId">
          <el-input v-model="form.outSkuId" placeholder="请输入sku编码" />
        </el-form-item>
        <el-form-item label="价格" prop="price">
          <el-input v-model="form.price" placeholder="请输入价格" />
        </el-form-item>
        <el-form-item label="展示图片" prop="pic">
          <!--          <el-input v-model="form.pic" placeholder="请输入展示图片" />-->
          <oss-image-upload v-model="form.pic" :limit="1" />
        </el-form-item>
        <el-form-item label="商品销售属性" prop="spData">
          <el-input :rows="5" style="width: 360px" v-model="form.spData" type="textarea" placeholder="商品销售属性，json格式" />
          <el-row>商品销售属性，<span style="color: red">json</span> 格式</el-row>
        </el-form-item>
      </el-form>
      <template v-slot:footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script>
import { listPmsSku, getPmsSku, delPmsSku, addPmsSku, updatePmsSku, exportPmsSku } from '@/api/pms/sku';
import { listPmsProduct } from '@/api/pms/product';
export default {
  name: 'PmsSku',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // sku信息表格数据
      pmsSkuList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productId: null,
        outSkuId: null,
        price: null,
        pic: null,
        spData: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        outSkuId: [{ required: true, message: 'sku编码不能为空', trigger: 'blur' }]
      },
      productSelectLoading: false,
      productSelectOption: [],
      productModalSelectLoading: false,
      productModalSelectOption: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    // 列表查询，查询人员列表
    getProductListByName(params) {
      if (params) {
        this.productSelectLoading = true;
        const query = { current: 1, size: 200, nameLike: params };
        const pageReq = { current: 1, size: 200 };
        listPmsProduct(query, pageReq).then((response) => {
          const { records = [] } = response.data || {};
          this.productSelectOption = records || [];
          this.productSelectLoading = false;
        });
      } else {
        this.productSelectOption = [];
        this.productSelectLoading = false;
      }
    },

    // 弹框新建编辑SKU信息，查询人员列表
    getModalProductListByName(params) {
      if (params) {
        this.productModalSelectLoading = true;
        const query = { current: 1, size: 200, nameLike: params };
        const pageReq = { current: 1, size: 200 };
        listPmsProduct(query, pageReq).then((response) => {
          const { records = [] } = response.data || {};
          this.productModalSelectOption = records || [];
          this.productModalSelectLoading = false;
        });
      } else {
        this.productModalSelectOption = [];
        this.productModalSelectLoading = false;
      }
    },

    /** 查询sku信息列表 */
    getList() {
      this.loading = true;
      const { pageNum, pageSize } = this.queryParams;
      const query = { ...this.queryParams, pageNum: undefined, pageSize: undefined };
      const pageReq = { page: pageNum - 1, size: pageSize };
      listPmsSku(query, pageReq).then((response) => {
        const { records, total } = response.data || {};
        this.pmsSkuList = records;
        this.total = total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        productId: null,
        outSkuId: null,
        price: null,
        pic: null,
        spData: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm('form');
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = '添加sku信息';
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getPmsSku(id).then((response) => {
        this.form = response.data || {};
        this.open = true;
        this.productModalSelectOption = [
          {
            id: this.form.productId,
            name: this.form.productName
          }
        ];
        this.title = '修改sku信息';
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updatePmsSku(this.form).then((response) => {
              this.$modal.msgSuccess('修改成功');
              this.open = false;
              this.getList();
            });
          } else {
            addPmsSku(this.form).then((response) => {
              this.$modal.msgSuccess('新增成功');
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除sku信息编号为"' + ids + '"的数据项？')
        .then(function () {
          return delPmsSku(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess('删除成功');
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal
        .confirm('是否确认导出所有sku信息数据项？')
        .then(() => {
          this.exportLoading = true;
          return exportPmsSku(queryParams);
        })
        .then((response) => {
          this.$download.download(response);
          this.exportLoading = false;
        })
        .catch(() => {});
    }
  }
};
</script>
